#ifndef _PROXIMITY_H_
#define _PROXIMITY_H_

//#include <iostream>
//#include <stdlib.h>

//#include <ctype.h>
//#include <X11/Xlib.h>
//#include <X11/extensions/XTest.h>
//#include <unistd.h>

//#include <dbus/dbus.h>
//#include <dbus/dbus-glib.h>
//#include <pthread.h>

//#include "shortcutd.h"
//#include <sys/types.h>
//#include <sys/stat.h>

#include "launcher.h"

#define INTERVAL_IDLE 1000000
#define INTERVAL_ACTIVE 1000


class Launcher;

class ProximitySensor
{
	private:

		static ProximitySensor* me;
		int tapDuration;
		int tapDelta;
		int idleResetDuration;
		int dashDuration;
		int disableDuration;
		int phoneDuration;

		char currentState;

		int tap;
		int on;
		int counter;
		int idleCounter;
		int keyboardLocked;

		

		int connectedLock;
		DBusMessage* msgLock;
		DBusMessageIter argsLock;
		DBusConnection* connLock;
		DBusError errLock;
		int retLock;
		const char* sigvalueLock;

		int connectedVib;
		DBusMessage* msgVib;
		DBusMessageIter argsVib;
		DBusConnection* connVib;
		DBusError errVib;
		DBusPendingCall* pendingVib;
		int retVib;
		const char* paramVib;
		
		int connectedProx;
		DBusMessage* msgProx;
		DBusMessageIter argsProx;
		DBusConnection* connProx;
		DBusError errProx;
		int retProx;
		const char* sigvalueProx;
		
		void connectToDbusVibra();
		void vibrate(int type);
	
		
		void connectToDbusLock();
		
	

		void connectToDbusProx();
		
		DBusMessage* msgProxSen;
		DBusMessageIter argsProxSen;
		DBusPendingCall* pendingProxSen;

		Launcher* launcher;
		
		int ppid;
		void startSensor();
		void stopSensor();
		
		char readProx();
		int inCheck;

		pthread_t sensorThread;

		static void* checkSensor(void* pObject);		


		void doShortPress();
		void doLongPress();
		void doHold();



	public:
		ProximitySensor(Launcher* launcher_);
		~ProximitySensor();
		int interval;
		void start();

		std::string shortPress;
		std::string longPress;
		std::string hold;
		static DBusHandlerResult DBusCallback( DBusConnection* connection,DBusMessage* message, void* user_data);
		DBusConnection* GetSessionDBus();
		DBusConnection* GetSystemDBus();
		int vibrateOn;
};

#endif
